package com.jkcredit.sysnews.config;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.cors.CorsConfiguration;
import org.springframework.web.cors.UrlBasedCorsConfigurationSource;
import org.springframework.web.filter.CorsFilter;
import org.springframework.web.servlet.config.annotation.CorsRegistry;
import org.springframework.web.servlet.config.annotation.ResourceHandlerRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

/**
 * @description:
 * @author: xusonglin
 * @create: 2020/3/5 13:42
 * @version: V1.0
 **/
@Configuration
public class CorsConfig implements WebMvcConfigurer {

    private CorsConfiguration buildConfig() {
        CorsConfiguration corsConfiguration = new CorsConfiguration();
//        corsConfiguration.setAllowCredentials(true);
        corsConfiguration.addAllowedOrigin("*"); //允许任何域名
        corsConfiguration.addAllowedHeader("*"); //允许任何头
        corsConfiguration.addAllowedMethod("*"); //允许任何方法
        corsConfiguration.addExposedHeader("Authorization");
        return corsConfiguration;
    }

    @Bean
    public CorsFilter corsFilter() {
        UrlBasedCorsConfigurationSource source = new UrlBasedCorsConfigurationSource();
        source.registerCorsConfiguration("/**", buildConfig()); //注册
        return new CorsFilter(source);
    }

    @Override
    public void addCorsMappings(CorsRegistry registry) {
        registry.addMapping("/**")
                .allowedOrigins("*")
                .allowCredentials(true)
                .allowedMethods("GET", "POST")
                .maxAge(3600);
    }

    @Override
    public void addResourceHandlers(ResourceHandlerRegistry registry) {
        registry.addResourceHandler("/app/image/**").addResourceLocations("/home/jknews/news/photo/");
    }


    //http://127.0.0.1:8081/app/page/newsArticles
    //http://127.0.0.1:8081/app/photo/upload
    //http://127.0.0.1:8081/app/images/202003091435211231234.png
    //http://127.0.0.1:8081/app/images/202003091435211231235.png
    //http://127.0.0.1:8081/app/images/202003091435211231236.png

    /*
    application.properties
    jkcredit.news.images.upload.path=/home/news/beans/photo
    jkcredit.news.images.virthr.path=/home/news/beans/photo
    jkcredit.news.access.url=https://127.0.0.1:8081
    jkcredit.news.access.url=https://news.jkcredit.cn




    File mkdir upload.path
    IMAGE /201.png
    ${jkcredit.news.access.url}${/app/images}/201.png



     */

}
